#ifndef INCLUDED_luxe_utils_json_JSONDecoder
#define INCLUDED_luxe_utils_json_JSONDecoder

#ifndef HXCPP_H
#include <hxcpp.h>
#endif

HX_DECLARE_CLASS3(luxe,utils,json,JSONDecoder)
HX_DECLARE_CLASS3(luxe,utils,json,JSONToken)
HX_DECLARE_CLASS3(luxe,utils,json,JSONTokenizer)
namespace luxe{
namespace utils{
namespace json{


class HXCPP_CLASS_ATTRIBUTES  JSONDecoder_obj : public hx::Object{
	public:
		typedef hx::Object super;
		typedef JSONDecoder_obj OBJ_;
		JSONDecoder_obj();
		Void __construct(::String s,bool strict);

	public:
		inline void *operator new( size_t inSize, bool inContainer=true)
			{ return hx::Object::operator new(inSize,inContainer); }
		static hx::ObjectPtr< JSONDecoder_obj > __new(::String s,bool strict);
		static Dynamic __CreateEmpty();
		static Dynamic __Create(hx::DynamicArray inArgs);
		//~JSONDecoder_obj();

		HX_DO_RTTI;
		static void __boot();
		static void __register();
		void __Mark(HX_MARK_PARAMS);
		void __Visit(HX_VISIT_PARAMS);
		::String __ToString() const { return HX_CSTRING("JSONDecoder"); }

		bool strict;
		Dynamic value;
		::luxe::utils::json::JSONTokenizer tokenizer;
		::luxe::utils::json::JSONToken token;
		virtual Dynamic getValue( );
		Dynamic getValue_dyn();

		virtual ::luxe::utils::json::JSONToken nextToken( );
		Dynamic nextToken_dyn();

		virtual Dynamic parseArray( );
		Dynamic parseArray_dyn();

		virtual Dynamic parseObject( );
		Dynamic parseObject_dyn();

		virtual Dynamic parseValue( );
		Dynamic parseValue_dyn();

};

} // end namespace luxe
} // end namespace utils
} // end namespace json

#endif /* INCLUDED_luxe_utils_json_JSONDecoder */ 
